Index: java/main/src/main/java/com/framsticks/remote/RemoteTree.java
===================================================================
--- java/main/src/main/java/com/framsticks/remote/RemoteTree.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/remote/RemoteTree.java	(revision 101)
@@ -7,8 +7,9 @@
 import com.framsticks.communication.queries.SetRequest;
 import com.framsticks.core.AbstractTree;
+import com.framsticks.core.ListChange;
 import com.framsticks.core.Path;
+import com.framsticks.core.ValueChange;
 import com.framsticks.params.*;
 import com.framsticks.params.EventListener;
-import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
@@ -17,9 +18,7 @@
 import com.framsticks.parsers.Loaders;
 import com.framsticks.parsers.MultiParamLoader;
-import com.framsticks.core.Tree;
 import com.framsticks.util.*;
 import com.framsticks.util.dispatching.AtOnceDispatcher;
 import com.framsticks.util.dispatching.Dispatching;
-import com.framsticks.util.dispatching.Dispatching.DispatcherWaiter;
 import com.framsticks.util.dispatching.DispatchingFuture;
 import com.framsticks.util.dispatching.ExceptionResultHandler;
@@ -52,20 +51,19 @@
 
 	public RemoteTree() {
+		bufferedDispatcher.setBuffer(true);
+		registry.registerAndBuild(ListChange.class);
+		registry.registerAndBuild(ValueChange.class);
 	}
 
 	@ParamAnnotation
 	public void setAddress(String address) {
-		setConnection(Connection.to(new ClientSideManagedConnection(), new Address(address)));
-	}
-
-	@ParamAnnotation
+		this.connection = Connection.to(new ClientSideManagedConnection(), new Address(address));
+		this.connection.setExceptionHandler(this);
+		this.connection.setNeedFileAcceptor(this);
+	}
+
+	@ParamAnnotation(flags = ParamFlags.USERREADONLY)
 	public String getAddress() {
 		return connection == null ? "<disconnected>" : connection.getAddress().toString();
-	}
-
-	@AutoAppendAnnotation
-	public void setConnection(final ClientSideManagedConnection connection) {
-		this.connection = connection;
-		this.connection.setExceptionHandler(this);
 	}
 
@@ -219,18 +217,17 @@
 		super.joinableStart();
 
-		dispatch(new RunAt<RemoteTree>(ThrowExceptionHandler.getInstance()) {
+		bufferedDispatcher.getTargetDispatcher().dispatch(new RunAt<RemoteTree>(ThrowExceptionHandler.getInstance()) {
 			@Override
 			protected void runAt() {
-				final DispatcherWaiter<Tree, Tree> waiter = new DispatcherWaiter<Tree, Tree>(RemoteTree.this);
-
-				connection.send(new InfoRequest().path("/"), waiter, new ClientSideResponseFuture(this) {
+
+				connection.send(new InfoRequest().path("/"), bufferedDispatcher.getTargetDispatcher(), new ClientSideResponseFuture(this) {
 					@Override
 					protected void processOk(Response response) {
 						FramsClass framsClass = processFetchedInfo(RemoteTree.this, response.getFiles().get(0));
 						assignRootParam(Param.build().name("Tree").id(RemoteTree.this.getName()).type("o " + framsClass.getId()).finish(CompositeParam.class));
+						bufferedDispatcher.setBuffer(false);
 					}
 				});
 
-				waiter.waitFor();
 			}
 		});
@@ -295,15 +292,9 @@
 					protected void runAt() {
 						assert isActive();
-						if (argumentType.equals(Object.class)) {
+						if (argumentType.equals(File.class)) {
 							listener.action(Casting.tryCast(argumentType, file));
 							return;
 						}
-						Access access = registry.createAccess(argumentType);
-						Object argument = access.createAccessee();
-						access.select(argument);
-						if (!argumentType.isInstance(argument)) {
-							throw new FramsticksException().msg("created argument is of wrond type").arg("expected", argumentType).arg("created", argument.getClass());
-						}
-						A typedArgument = argumentType.cast(argument);
+						// Access access = registry.createAccess(argumentType);
 
 						// log.info("executing event with argument {}", argumentType);
@@ -311,8 +302,16 @@
 						loader.setNewSource(file.getContent());
 						loader.addBreakCondition(MultiParamLoader.Status.AfterObject);
-						loader.addAccess(access);
+						loader.setAccessProvider(registry);
+						// loader.addAccess(access);
 						loader.go();
-
-						listener.action(typedArgument);
+						Object argument = loader.getLastAccess().getSelected();
+						// Object argument = access.getSelected();
+						if (argument == null) {
+							listener.action(null);
+						}
+						if (!argumentType.isInstance(argument)) {
+							throw new FramsticksException().msg("created argument is of wrong type").arg("expected", argumentType).arg("created", argument.getClass());
+						}
+						listener.action(argumentType.cast(argument));
 					}
 				});
Index: java/main/src/main/java/com/framsticks/running/ExternalProcess.java
===================================================================
--- java/main/src/main/java/com/framsticks/running/ExternalProcess.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/running/ExternalProcess.java	(revision 101)
@@ -8,5 +8,4 @@
 import java.io.PrintWriter;
 import java.util.ArrayList;
-import java.util.LinkedList;
 import java.util.List;
 
@@ -15,4 +14,8 @@
 import org.apache.logging.log4j.LogManager;
 
+import com.framsticks.core.ValueChange;
+import com.framsticks.params.EventListener;
+import com.framsticks.params.EventListeners;
+import com.framsticks.params.ParamFlags;
 import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
@@ -42,11 +45,20 @@
 	protected BufferedReader output;
 	protected Integer exitCode;
-
-	protected final List<OutputListener> listeners = new LinkedList<>();
+	protected String echoInput;
+
+	protected final EventListeners<ValueChange> listeners = new EventListeners<>();
 
 	@AutoAppendAnnotation
-	public void addListener(OutputListener listener) {
+	@ParamAnnotation(id = "line_output")
+	public void addOutputListener(EventListener<ValueChange> listener) {
 		synchronized (listeners) {
 			listeners.add(listener);
+		}
+	}
+
+	@ParamAnnotation(id = "line_output")
+	public void removeOutputListener(EventListener<ValueChange> listener) {
+		synchronized (listeners) {
+			listeners.remove(listener);
 		}
 	}
@@ -65,5 +77,5 @@
 	 * @return the command
 	 */
-	@ParamAnnotation
+	@ParamAnnotation(flags = ParamFlags.USERREADONLY)
 	public String getCommand() {
 		return arguments.get(0);
@@ -80,4 +92,5 @@
 	protected void readerTask() {
 
+		log.debug("reading output from " + this);
 		String line;
 		try {
@@ -86,7 +99,5 @@
 					log.trace("read line: {}", line);
 					synchronized (listeners) {
-						for (OutputListener l : listeners) {
-							l.onLineRead(line);
-						}
+						listeners.actionForAll(new ValueChange(line));
 					}
 				}
@@ -104,9 +115,9 @@
 			log.error("exception caught in process {}", this, e);
 		}
-		interrupt();
+		interruptJoinable();
 		// finish();
 	}
 
-	@ParamAnnotation
+	@ParamAnnotation(flags = ParamFlags.USERREADONLY)
 	public void setDirectory(String directory) {
 		builder.directory(new File(directory));
@@ -115,5 +126,5 @@
 	@ParamAnnotation
 	public String getDirectory() {
-		return builder.directory().getName();
+		return builder.directory() != null ? builder.directory().getName() : ".";
 	}
 
@@ -140,4 +151,9 @@
 		});
 		Dispatching.use(readerThread, this);
+
+		if (echoInput != null) {
+			input.println(echoInput);
+			input.flush();
+		}
 	}
 
@@ -152,4 +168,20 @@
 	public PrintWriter getInput() {
 		return input;
+	}
+
+	/**
+	 * @return the echoInput
+	 */
+	@ParamAnnotation(flags = ParamFlags.USERREADONLY)
+	public String getEchoInput() {
+		return echoInput;
+	}
+
+	/**
+	 * @param echoInput the echoInput to set
+	 */
+	@ParamAnnotation
+	public void setEchoInput(String echoInput) {
+		this.echoInput = echoInput;
 	}
 
@@ -162,5 +194,5 @@
 
 	@Override
-	@ParamAnnotation
+	@ParamAnnotation(flags = ParamFlags.USERREADONLY)
 	public String getName() {
 		return readerThread.getName();
Index: java/main/src/main/java/com/framsticks/running/LoggingOutputListener.java
===================================================================
--- java/main/src/main/java/com/framsticks/running/LoggingOutputListener.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/running/LoggingOutputListener.java	(revision 101)
@@ -4,8 +4,10 @@
 import org.apache.logging.log4j.LogManager;
 
+import com.framsticks.core.ValueChange;
+import com.framsticks.params.EventListener;
 import com.framsticks.params.annotations.FramsClassAnnotation;
 
 @FramsClassAnnotation
-public class LoggingOutputListener implements OutputListener {
+public class LoggingOutputListener implements EventListener<ValueChange> {
 	private static final Logger log =
 		LogManager.getLogger(LoggingOutputListener.class);
@@ -13,6 +15,6 @@
 
 	@Override
-	public void onLineRead(String line) {
-		log.info(line);
+	public void action(ValueChange change) {
+		log.info(change.toString());
 	}
 
Index: java/main/src/main/java/com/framsticks/test/PrimeExperiment.java
===================================================================
--- java/main/src/main/java/com/framsticks/test/PrimeExperiment.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/test/PrimeExperiment.java	(revision 101)
@@ -0,0 +1,9 @@
+package com.framsticks.test;
+
+import com.framsticks.experiment.Experiment;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+
+@FramsClassAnnotation
+public class PrimeExperiment extends Experiment {
+
+}
Index: java/main/src/main/java/com/framsticks/test/TestChangeEvent.java
===================================================================
--- java/main/src/main/java/com/framsticks/test/TestChangeEvent.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/test/TestChangeEvent.java	(revision 101)
@@ -0,0 +1,17 @@
+package com.framsticks.test;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+
+@FramsClassAnnotation
+public class TestChangeEvent {
+
+	@ParamAnnotation
+	public String history;
+
+	@Override
+	public String toString() {
+		return "[test change event: " + history + "]";
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/test/TestChild.java
===================================================================
--- java/main/src/main/java/com/framsticks/test/TestChild.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/test/TestChild.java	(revision 101)
@@ -1,14 +1,13 @@
 package com.framsticks.test;
 
-import com.framsticks.core.ListChange;
+import com.framsticks.params.AbstractUniqueObject;
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
 
 @FramsClassAnnotation
-public class TestChild {
+public class TestChild extends AbstractUniqueObject {
 
 	protected String name = "child";
 
-	protected String uid;
 	protected final TestClass parent;
 	/**
@@ -17,5 +16,4 @@
 	public TestChild(TestClass parent) {
 		this.parent = parent;
-		this.uid = "c" + (parent.counter++);
 	}
 
@@ -34,13 +32,5 @@
 	public void setName(String name) {
 		this.name = name;
-		parent.fireChildrenChange(this, ListChange.Action.Modify);
-	}
-
-	/**
-	 * @return the uid
-	 */
-	@ParamAnnotation
-	public String getUid() {
-		return uid;
+		parent.children.modify(this);
 	}
 
Index: java/main/src/main/java/com/framsticks/test/TestClass.java
===================================================================
--- java/main/src/main/java/com/framsticks/test/TestClass.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/test/TestClass.java	(revision 101)
@@ -1,7 +1,4 @@
 package com.framsticks.test;
 
-import java.util.Collections;
-import java.util.LinkedList;
-import java.util.List;
 import java.util.Map;
 
@@ -11,5 +8,6 @@
 import com.framsticks.core.ListChange;
 import com.framsticks.params.EventListener;
-import com.framsticks.params.UniqueListAccess;
+import com.framsticks.params.EventListeners;
+import com.framsticks.params.SimpleUniqueList;
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
@@ -26,9 +24,4 @@
 		"createChild",
 		"children_changed"
-	},
-	register = {
-		ChangeEvent.class,
-		TestChild.class,
-		ListChange.class
 	}
 )
@@ -40,9 +33,7 @@
 	protected String name = "test";
 	protected String history = "initial|";
-	protected final List<EventListener<ChangeEvent>> historyListeners = new LinkedList<>();
-	protected final List<EventListener<ListChange>> childrenListeners = new LinkedList<>();
+	protected final EventListeners<TestChangeEvent> historyListeners = new EventListeners<>();
 
-	protected final Map<String, TestChild> children = UniqueListAccess.createMap(TestChild.class, this);
-	protected int counter = 0;
+	protected final SimpleUniqueList<TestChild> children = new SimpleUniqueList<>(TestChild.class, 'c');
 
 	/**
@@ -89,5 +80,5 @@
 	@ParamAnnotation
 	public Map<String, TestChild> getChildren() {
-		return Collections.unmodifiableMap(children);
+		return children.getView();
 	}
 
@@ -111,30 +102,21 @@
 		TestChild child = new TestChild(this);
 		child.name = name;
-		children.put(child.getUid(), child);
-		fireChildrenChange(child, ListChange.Action.Add);
+		children.add(child);
 	}
 
 	protected void fireHistoryChange() {
-		for (EventListener<ChangeEvent> l : historyListeners) {
-			ChangeEvent event = new ChangeEvent();
-			event.history = history;
-			l.action(event);
-		}
+		TestChangeEvent event = new TestChangeEvent();
+		event.history = history;
+		historyListeners.actionForAll(event);
 	}
 
-	protected void fireChildrenChange(TestChild child, ListChange.Action action) {
-		ListChange change = new ListChange(action, UniqueListAccess.getNumberInMap(children, child), child.getUid());
-		for (EventListener<ListChange> l : childrenListeners) {
-			l.action(change);
-		}
-	}
 
 	@ParamAnnotation(id = "history_changed")
-	public void addHistoryListener(EventListener<ChangeEvent> listener) {
+	public void addHistoryListener(EventListener<TestChangeEvent> listener) {
 		historyListeners.add(listener);
 	}
 
 	@ParamAnnotation(id = "history_changed")
-	public void removeHistoryListener(EventListener<ChangeEvent> listener) {
+	public void removeHistoryListener(EventListener<TestChangeEvent> listener) {
 		historyListeners.remove(listener);
 	}
@@ -142,10 +124,10 @@
 	@ParamAnnotation(id = "children_changed")
 	public void addChildrenListener(EventListener<ListChange> listener) {
-		childrenListeners.add(listener);
+		children.addListener(listener);
 	}
 
 	@ParamAnnotation(id = "children_changed")
 	public void removeChildrenListener(EventListener<ListChange> listener) {
-		childrenListeners.remove(listener);
+		children.removeListener(listener);
 	}
 
Index: java/main/src/main/java/com/framsticks/util/FramsticksUnsupportedOperationException.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/FramsticksUnsupportedOperationException.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/util/FramsticksUnsupportedOperationException.java	(revision 101)
@@ -0,0 +1,13 @@
+package com.framsticks.util;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public class FramsticksUnsupportedOperationException extends FramsticksException {
+
+	/**
+	 *
+	 */
+	private static final long serialVersionUID = -8006030446614381094L;
+
+}
Index: java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java	(revision 101)
@@ -39,5 +39,5 @@
 		synchronized (joinablesRegistry) {
 			for (AbstractJoinable j : joinablesRegistry) {
-				b.append("\n").append(j.getState()).append(" : ").append(j);
+				b.append("\n").append(j.getState()).append(" : ").append(j).append(" - ").append(j.getClass());
 			}
 		}
@@ -73,5 +73,5 @@
 
 
-	public final boolean start() {
+	protected final boolean startJoinable() {
 		if (changeState(JoinableState.RUNNING)) {
 			joinableStart();
@@ -81,5 +81,5 @@
 	}
 
-	public final boolean interrupt() {
+	protected final boolean interruptJoinable() {
 		if (changeState(JoinableState.FINISHING)) {
 			joinableInterrupt();
@@ -89,5 +89,5 @@
 	}
 
-	protected final boolean finish() {
+	protected final boolean finishJoinable() {
 		if (changeState(JoinableState.JOINABLE)) {
 			joinableFinish();
@@ -118,9 +118,9 @@
 		switch (state) {
 			case RUNNING:
-				return start();
+				return startJoinable();
 			case FINISHING:
-				return interrupt();
+				return interruptJoinable();
 			case JOINABLE:
-				return finish();
+				return finishJoinable();
 			default: return false;
 		}
@@ -149,5 +149,5 @@
 			assert monitor == null;
 			monitor = owner.getMonitor();
-			return this.start();
+			return this.startJoinable();
 		}
 		return false;
@@ -170,5 +170,5 @@
 				@Override
 				protected void runAt() {
-					interrupt();
+					interruptJoinable();
 				}
 			});
Index: java/main/src/main/java/com/framsticks/util/dispatching/AtOnceDispatcher.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/AtOnceDispatcher.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/util/dispatching/AtOnceDispatcher.java	(revision 101)
@@ -5,5 +5,5 @@
  * @author Piotr Sniegowski
  */
-public class AtOnceDispatcher<C> extends AbstractJoinable implements JoinableDispatcher<C> {
+public class AtOnceDispatcher<C> extends AbstractJoinable implements Dispatcher<C> {
 
 	@SuppressWarnings("rawtypes")
@@ -37,5 +37,5 @@
 	@Override
 	protected void joinableInterrupt() {
-		finish();
+		finishJoinable();
 	}
 
Index: java/main/src/main/java/com/framsticks/util/dispatching/BufferedDispatcher.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/BufferedDispatcher.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/util/dispatching/BufferedDispatcher.java	(revision 101)
@@ -0,0 +1,58 @@
+package com.framsticks.util.dispatching;
+
+
+public class BufferedDispatcher<C> {
+
+	protected final RunnableQueue<C> queue = new RunnableQueue<>();
+
+	protected Dispatcher<C> targetDispatcher;
+
+	protected boolean buffer = false;
+
+	/**
+	 * @return the targetDispatcher
+	 */
+	public synchronized Dispatcher<C> getTargetDispatcher() {
+		return targetDispatcher;
+	}
+
+	/**
+	 * @param targetDispatcher the targetDispatcher to set
+	 */
+	public synchronized void setTargetDispatcher(Dispatcher<C> targetDispatcher) {
+		this.targetDispatcher = targetDispatcher;
+	}
+
+	public synchronized boolean isActive() {
+		if (targetDispatcher == null) {
+			return false;
+			// throw new FramsticksException().msg("no dispatcher is set for tree yet").arg("tree", this);
+		}
+		return targetDispatcher.isActive();
+	}
+
+	public synchronized void dispatch(final RunAt<? extends C> runnable) {
+		if (targetDispatcher != null && !buffer) {
+			targetDispatcher.dispatch(runnable);
+			return;
+		}
+		queue.push(runnable);
+	}
+
+	public synchronized void setBuffer(final boolean buffer) {
+		if (this.buffer == buffer) {
+			return;
+		}
+		if (buffer) {
+			this.buffer = true;
+			return;
+		}
+		this.buffer = false;
+		while (!queue.isEmpty()) {
+			targetDispatcher.dispatch(queue.pollFirst());
+		}
+
+	}
+
+
+}
Index: java/main/src/main/java/com/framsticks/util/dispatching/Dispatcher.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Dispatcher.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Dispatcher.java	(revision 101)
@@ -4,5 +4,5 @@
  * @author Piotr Sniegowski
  */
-public interface Dispatcher<C> {
+public interface Dispatcher<C> extends Joinable {
 	public boolean isActive();
 	public void dispatch(RunAt<? extends C> runnable);
Index: java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 101)
@@ -1,3 +1,5 @@
 package com.framsticks.util.dispatching;
+
+import java.util.Timer;
 
 import org.apache.logging.log4j.Logger;
@@ -11,4 +13,10 @@
 public abstract class Dispatching {
 	private static final Logger log = LogManager.getLogger(Dispatching.class);
+
+	protected static final Timer timer = new Timer();
+
+	public static Timer getTimer() {
+		return timer;
+	}
 
 	public static boolean isThreadSafe() {
@@ -183,41 +191,41 @@
 	}
 
-	public static class DispatcherWaiter<C, T extends Dispatcher<C> & Joinable> implements Dispatcher<C> {
-		// protected boolean done = false;
-		protected final T dispatcher;
-		protected RunAt<? extends C> runnable;
-
-		/**
-		 * @param joinable
-		 */
-		public DispatcherWaiter(T dispatcher) {
-			this.dispatcher = dispatcher;
-		}
-
-		public synchronized void waitFor() {
-			while ((runnable == null) && (dispatcher.getState().ordinal() <= JoinableState.RUNNING.ordinal())) {
-				try {
-					this.wait();
-				} catch (InterruptedException e) {
-				}
-			}
-			if (runnable != null) {
-				runnable.run();
-			}
-
-		}
-
-		@Override
-		public boolean isActive() {
-			return dispatcher.isActive();
-		}
-
-		@Override
-		public synchronized void dispatch(RunAt<? extends C> runnable) {
-			this.runnable = runnable;
-			this.notifyAll();
-		}
-
-	}
+	// public static class DispatcherWaiter<C, T extends Dispatcher<C> & Joinable> implements Dispatcher<C> {
+	// 	// protected boolean done = false;
+	// 	protected final T dispatcher;
+	// 	protected RunAt<? extends C> runnable;
+
+	// 	/**
+	// 	 * @param joinable
+	// 	 */
+	// 	public DispatcherWaiter(T dispatcher) {
+	// 		this.dispatcher = dispatcher;
+	// 	}
+
+	// 	public synchronized void waitFor() {
+	// 		while ((runnable == null) && (dispatcher.getState().ordinal() <= JoinableState.RUNNING.ordinal())) {
+	// 			try {
+	// 				this.wait();
+	// 			} catch (InterruptedException e) {
+	// 			}
+	// 		}
+	// 		if (runnable != null) {
+	// 			runnable.run();
+	// 		}
+
+	// 	}
+
+	// 	@Override
+	// 	public boolean isActive() {
+	// 		return dispatcher.isActive();
+	// 	}
+
+	// 	@Override
+	// 	public synchronized void dispatch(RunAt<? extends C> runnable) {
+	// 		this.runnable = runnable;
+	// 		this.notifyAll();
+	// 	}
+
+	// }
 
 	public static class Waiter {
Index: java/main/src/main/java/com/framsticks/util/dispatching/JoinableCollection.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/JoinableCollection.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/util/dispatching/JoinableCollection.java	(revision 101)
@@ -8,6 +8,8 @@
 import java.util.Set;
 
+import com.framsticks.params.ParamFlags;
 import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.Misc;
@@ -72,5 +74,5 @@
 	protected void joinableInterrupt() {
 		if (joinables.isEmpty()) {
-			finish();
+			finishJoinable();
 			return;
 		}
@@ -137,5 +139,5 @@
 	public T get(String name) {
 		for (T j : joinables) {
-			if (j.getName().equals(name)) {
+			if (name.equals(j.getName())) {
 				return j;
 			}
@@ -153,6 +155,12 @@
 
 	@Override
+	@ParamAnnotation
 	public String getName() {
 		return observableName;
+	}
+
+	@ParamAnnotation(flags = ParamFlags.USERREADONLY)
+	public final void setName(String name) {
+		observableName = name;
 	}
 
@@ -185,3 +193,5 @@
 	}
 
+
+
 }
Index: java/main/src/main/java/com/framsticks/util/dispatching/RunnableQueue.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/RunnableQueue.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/util/dispatching/RunnableQueue.java	(revision 101)
@@ -0,0 +1,21 @@
+package com.framsticks.util.dispatching;
+
+import java.util.LinkedList;
+
+public class RunnableQueue<C> {
+
+	protected final LinkedList<RunAt<? extends C>> queue = new LinkedList<>();
+
+	public boolean isEmpty() {
+		return queue.isEmpty();
+	}
+
+	public RunAt<? extends C> pollFirst() {
+		return queue.pollFirst();
+	}
+
+	public void push(RunAt<? extends C> runnable) {
+		queue.add(runnable);
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/util/dispatching/Thread.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Thread.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Thread.java	(revision 101)
@@ -3,7 +3,4 @@
 import org.apache.logging.log4j.Logger;
 import org.apache.logging.log4j.LogManager;
-
-import java.util.LinkedList;
-import java.util.ListIterator;
 
 
@@ -14,5 +11,5 @@
  * @author Piotr Sniegowski
  */
-public class Thread<C> extends AbstractJoinable implements JoinableDispatcher<C> {
+public class Thread<C> extends AbstractJoinable implements Dispatcher<C> {
 
 	private static final Logger log = LogManager.getLogger(Thread.class);
@@ -20,8 +17,9 @@
 	protected final java.lang.Thread thread;
 
-	private final LinkedList<Task<? extends C>> queue = new LinkedList<>();
+	protected final Object condition = new Object();
+	private RunnableQueue<C> queue = new RunnableQueue<>();
 
 	public Thread() {
-		thread = new java.lang.Thread(new java.lang.Runnable() {
+		thread = new java.lang.Thread(new Runnable() {
 			@Override
 			public void run() {
@@ -30,5 +28,4 @@
 		});
 	}
-
 
 	public Thread(java.lang.Thread thread) {
@@ -51,9 +48,9 @@
 		ExceptionHandler exceptionHandler = getMonitor().getTaskExceptionHandler();
 		while (!java.lang.Thread.interrupted()) {
-			Task<? extends C> task;
-			synchronized (queue) {
+			RunAt<? extends C> runnable;
+			synchronized (condition) {
 				if (queue.isEmpty()) {
 					try {
-						queue.wait();
+						condition.wait();
 					} catch (InterruptedException ignored) {
 						break;
@@ -61,72 +58,38 @@
 					continue;
 				}
-				task = queue.peekFirst();
-				assert task != null;
-				if (task.moment > System.currentTimeMillis()) {
-					try {
-						queue.wait(task.moment - System.currentTimeMillis());
-					} catch (InterruptedException ignored) {
-						continue;
+				runnable = queue.pollFirst();
+			}
+			if (runnable != null) {
+				try {
+					runnable.run();
+				} catch (Exception e) {
+					if (exceptionHandler != null) {
+						if (exceptionHandler.handle(this, e)) {
+							continue;
+						}
 					}
-					continue;
+					log.error("error in thread: ", e);
 				}
-				queue.pollFirst();
-			}
-			try {
-				task.run();
-			} catch (Exception e) {
-				if (exceptionHandler != null) {
-					if (exceptionHandler.handle(this, e)) {
-						continue;
-					}
-				}
-				log.error("error in thread: ", e);
 			}
 		}
 		log.debug("finishing thread {}", this);
-		finish();
+		finishJoinable();
 	}
 
-	protected void enqueueTask(Task<? extends C> task) {
-		synchronized (queue) {
-			ListIterator<Task<? extends C>> i = queue.listIterator();
-			while (i.hasNext()) {
-				Task<? extends C> t = i.next();
-				if (t.getMoment() > task.getMoment()) {
-					i.previous();
-					i.add(task);
-					task = null;
-					break;
-				}
-			}
-			if (task != null) {
-				queue.add(task);
-			}
 
-			/*
-			Iterator<Task> j = queue.iterator();
-			Task prev = null;
-			while (j.hasNext()) {
-				Task next = j.next();
-				assert (prev == null) || prev.getMoment() <= next.getMoment();
-				prev = next;
-			}
-			*/
-			queue.notify();
+	@Override
+	public void dispatch(RunAt<? extends C> runnable) {
+		synchronized (condition) {
+			queue.push(runnable);
+			condition.notifyAll();
 		}
 	}
 
-	@Override
-	public void dispatch(final RunAt<? extends C> runnable) {
-		if (!(runnable instanceof Task)) {
-			enqueueTask(new Task<C>(runnable) {
-				@Override
-				protected void runAt() {
-					runnable.run();
-				}
-			});
-			return;
+	public RunnableQueue<C> switchQueue(RunnableQueue<C> queue) {
+		synchronized (condition) {
+			RunnableQueue<C> result = this.queue;
+			this.queue = queue;
+			return result;
 		}
-		enqueueTask((Task<? extends C>) runnable);
 	}
 
Index: java/main/src/main/java/com/framsticks/util/lang/Holder.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/lang/Holder.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/util/lang/Holder.java	(revision 101)
@@ -33,3 +33,7 @@
 	}
 
+	public static <T2> Holder<T2> make(T2 value) {
+		return new Holder<T2>(value);
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/util/lang/Strings.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/lang/Strings.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/util/lang/Strings.java	(revision 101)
@@ -1,3 +1,5 @@
 package com.framsticks.util.lang;
+
+import java.util.regex.Matcher;
 
 import com.framsticks.util.FramsticksException;
@@ -78,3 +80,8 @@
 	}
 
+	public static CharSequence takeGroup(CharSequence input, Matcher matcher, int group) {
+		// return (matcher.start(group) == matcher.end(group)) ? null : input.subSequence(matcher.start(group), matcher.end(group));
+		return input.subSequence(matcher.start(group), matcher.end(group));
+	}
+
 }
Index: java/main/src/test/java/com/framsticks/communication/RequestTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/communication/RequestTest.java	(revision 100)
+++ java/main/src/test/java/com/framsticks/communication/RequestTest.java	(revision 101)
@@ -28,4 +28,5 @@
 
 		assertThat(Request.takeRequestId(true, " 2 simple second")).isEqualTo(Pair.make(2, "simple second"));
+		assertThat(Request.takeRequestId(true, " -3 simple")).isEqualTo(Pair.make(-3, "simple"));
 	}
 
Index: java/main/src/test/java/com/framsticks/core/ListChangeTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/core/ListChangeTest.java	(revision 100)
+++ java/main/src/test/java/com/framsticks/core/ListChangeTest.java	(revision 101)
@@ -7,4 +7,5 @@
 
 import com.framsticks.core.ListChange.Action;
+import com.framsticks.params.AccessOperations;
 import com.framsticks.params.FramsClass;
 import com.framsticks.params.ListSink;
@@ -60,5 +61,5 @@
 	@Test(dependsOnMethods = "createReflectionAccess")
 	public void load() throws Exception {
-		access.select(listChange).load(ListSource.createFrom("type:2", "pos:0", "id:test"));
+		AccessOperations.load(access.select(listChange), ListSource.createFrom("type:2", "pos:0", "id:test"));
 
 		assertThat(listChange.action).isEqualTo(Action.Modify);
Index: java/main/src/test/java/com/framsticks/core/XmlBasedTest.java
===================================================================
--- java/main/src/test/java/com/framsticks/core/XmlBasedTest.java	(revision 100)
+++ java/main/src/test/java/com/framsticks/core/XmlBasedTest.java	(revision 101)
@@ -26,5 +26,7 @@
 	}
 
-	protected abstract String getConfigurationName();
+	protected String getConfigurationName() {
+		return this.getClass().getSimpleName() + ".xml";
+	}
 
 
